import com.github.jengelman.gradle.plugins.shadow.tasks.ShadowJar

plugins {
	kotlin("jvm") version "1.7.21"
	id("com.github.johnrengelman.shadow") version "7.1.0"
}

repositories {
	mavenCentral()
	mavenLocal()
	maven {
		url = uri("https://repo.runelite.net")
	}
}

val runeLiteVersion = "latest.release"

dependencies {
	compileOnly(group = "net.runelite", name = "client", version = runeLiteVersion)

	compileOnly("javax.inject:javax.inject:1")
	compileOnly("org.projectlombok:lombok:1.18.20")
	annotationProcessor("org.projectlombok:lombok:1.18.20")
}

tasks {
	named<ShadowJar>("shadowJar") {
		exclude("module-info.class")
		exclude("META-INF/")
		exclude("*META-INF*")
		exclude("META-INF*")
		exclude("*META-INF")
		exclude("META-INF")
	}
}

tasks {
	build {
		dependsOn(shadowJar)
	}
}

tasks {
    compileKotlin {
        kotlinOptions {
			jvmTarget = "1.8"
			freeCompilerArgs = listOf("-Xjvm-default=all")
		}
    }
    compileTestKotlin {
        kotlinOptions {
			jvmTarget = "1.8"
			freeCompilerArgs = listOf("-Xjvm-default=all")
		}
    }
}
